## rust-coreutils 0.2.2

=== Makefile ===
UseGNU=gmake $*
all:
	@$(UseGNU)
.DEFAULT:
	@$(UseGNU)

=== docs/Makefile ===
clean:
	rm -rf book
	rm -f src/SUMMARY.md
	rm -f src/utils/*

## rust-coreutils 0.0.14

=== debian/changelog ===
rust-coreutils (0.0.14-3) unstable; urgency=medium

  * Remove the ioctl dep and use the libc directly

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 10 Jun 2022 21:00:01 +0200

rust-coreutils (0.0.14-2) unstable; urgency=medium

  * Relax dep against exacl to unbreak the build
    and potentially fix the FTBFS

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 10 Jun 2022 08:05:39 +0200

rust-coreutils (0.0.14-1) unstable; urgency=medium

  * New upstream release
  * Added librust-selinux-dev, librust-conv-dev, librust-pretty-assertions-dev
    librust-time-dev, librust-unindent-dev, librust-rlimit-dev,
    librust-data-encoding-macro-dev, librust-dns-lookup-dev,
    librust-os-display-dev, librust-z85-dev, librust-fts-sys-dev,
    librust-exacl-dev, librust-byte-unit-dev, librust-gcd-dev,
    librust-signal-hook-dev, librust-paste-dev, librust-quickcheck-dev,
    librust-crossterm-dev, librust-bigdecimal-dev,
    librust-binary-heap-plus-dev, librust-ouroboros-dev,
    librust-memmap2-dev, librust-retain-mut-dev,
    librust-strum-dev, librust-utf-8-dev
    as new deps
  * Fix various dep issues (Closes: #995914)
  * Package coreutils 0.0.14 from crates.io using debcargo 2.5.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 05 Jun 2022 23:50:57 +0200

rust-coreutils (0.0.6-1~exp1) experimental; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Apr 2021 12:08:24 +0200

rust-coreutils (0.0.4-1~exp2) experimental; urgency=medium

  * Binaries have been moved in usr/lib/cargo/bin/coreutils
    The rationale is that some other rust programs are installed
    in this directory (ex: /usr/lib/cargo/bin/fd). So, users might
    add /usr/lib/cargo/bin/ to their PATH and caused some unexpected
    errors if the Rust coreutils binaries aren't behaving like GNU's.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 23 Mar 2021 10:57:54 +0100

rust-coreutils (0.0.4-1~exp1) experimental; urgency=medium

  * New upstream release
  * Rebase of the patches
  * Set a minimal version for platform-info
  * Use PROFILE=release instead of a silly sed

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 04 Feb 2021 11:28:54 +0100

rust-coreutils (0.0.3-1~exp2) experimental; urgency=medium

  * Set a minimal version for librust-hostname-dev
  * chroot, hashsum, hostname, kill, more, relpath and uptime were
    not installed
  * Add fail missing

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Feb 2021 17:02:19 +0100

rust-coreutils (0.0.3-1~exp1) experimental; urgency=medium

  * New upstream release
  * Add missing build dependency (librust-cpp-build-dev)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 02 Feb 2021 13:31:05 +0100

rust-coreutils (0.0.2-1~exp1) experimental; urgency=medium

  * Package coreutils 0.0.2 from crates.io using debcargo 2.4.4-alpha.0

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 11 Jan 2021 22:15:47 +0100

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 bash-completion,
 cargo:native,
 rustc:native,
 libstd-rust-dev,
 librust-clap-dev, librust-clap-complete-dev,
 librust-backtrace-dev,
 librust-half-1.6+default-dev | librust-half-1.3+default-dev | librust-half-1.2+default-dev | librust-half-1.1+default-dev,
 librust-lazy-static-1+default-dev (>= 1.3-~~),
 librust-same-file-1.0.6+default-dev | librust-same-file-1.0.5+default-dev | librust-same-file-1.0.4+default-dev,
 librust-textwrap-dev, librust-cc-dev,
 librust-quick-error-dev, librust-unix-socket-dev, librust-getopts-dev, librust-filetime-dev,
 librust-walkdir-dev, librust-xattr-dev, librust-number-prefix-dev,
 librust-rust-ini-dev, librust-failure-dev, librust-failure-derive-dev,
 librust-glob-dev, librust-chrono-dev, librust-onig-dev,
 librust-blake2-rfc-dev, librust-digest-dev, librust-hex-dev, librust-md5-dev,
 librust-sha1-dev, librust-sha2-dev, librust-sha3-dev,
 librust-atty-dev, librust-term-grid-dev, librust-termsize-dev,
 librust-tempfile-dev, librust-nix-dev (>= 0.23.1), librust-fs-extra-dev,
 librust-itertools-dev, librust-bit-set-dev, librust-dunce-dev,
 librust-data-encoding-dev, librust-platform-info-dev (>= 0.1),
 librust-num-traits-dev (>= 0.2.14), librust-smallvec-dev,
 librust-rand-pcg-dev, librust-thiserror-dev, librust-lazy-static-dev,
 librust-byteorder-dev, librust-hostname-dev (>= 0.3.1), librust-cpp-build-dev,
 librust-fnv-dev, librust-wild-dev, librust-cpp-dev, librust-thread-local-dev,
 librust-selinux-dev, librust-conv-dev, librust-pretty-assertions-dev (>= 1),
 librust-time-dev (>= 0.3.9), librust-unindent-dev, librust-rlimit-dev (>= 0.8.3),
 librust-data-encoding-macro-dev, librust-dns-lookup-dev, librust-os-display-dev,
 librust-z85-dev, librust-fts-sys-dev, librust-exacl-dev, librust-byte-unit-dev,
 librust-gcd-dev, librust-signal-hook-dev, librust-paste-dev, librust-quickcheck-dev,
 librust-crossterm-dev, librust-bigdecimal-dev, librust-binary-heap-plus-dev,
 librust-ouroboros-dev, librust-memmap2-dev, librust-retain-mut-dev,
 librust-strum-dev, librust-utf-8-dev, librust-phf-dev, librust-phf-codegen-dev,
 librust-zip-dev, librust-users-dev, librust-blake2b-simd-dev,
 librust-hex-literal-dev, librust-lscolors-dev, librust-blake3-dev,
 librust-file-diff-dev, librust-ctrlc-dev, librust-flate2-dev,
 librust-bstr-dev, librust-md-5-dev, librust-bytecount-dev,
 librust-regex-automata-dev,
 librust-backtrace-sys-dev, python3-sphinx, help2man
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * A few binaries are missing (ex: dd),
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.
 .
 It might break your system.
 .
 This is an EXPERIMENTAL package. It should not be used in
 production.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
%:
	dh $@ --buildsystem cargo --with bash-completion

override_dh_auto_clean:
	rm -f docs/*.1
	dh_auto_clean

override_dh_auto_test:

override_dh_auto_install:
	CARGO_HOME=$(shell pwd)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system
	CARGO_HOME=$(shell pwd)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make install PROFILE=release
	for f in $(CURDIR)/debian/tmp/usr/bin/*; do \
		filename=$$(basename $$f); \
		help2man $$f > docs/rust-$$filename.1; \
	done

	rm -f $(CURDIR)/debian/tmp/usr/local/man/man1/arch.1.gz

override_dh_missing:
	dh_missing --fail-missing

## rust-coreutils 0.0.17

=== debian/changelog ===
rust-coreutils (0.0.17-2) unstable; urgency=medium

  * Unbreak the s390x build

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 23 Jan 2023 23:14:48 +0100

rust-coreutils (0.0.17-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 21 Jan 2023 23:27:05 +0100

rust-coreutils (0.0.16-4) unstable; urgency=medium

  * Team upload.
  * Bump lscolors dependency to 0.14 and build-depend explicitly on it.
  * Build-depend explicitly on version 3 of clap.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 14 Jan 2023 00:02:28 +0000

rust-coreutils (0.0.16-3) unstable; urgency=medium

  * Relax the dep on nix to unbreak the build

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 21 Dec 2022 09:31:17 +0100

rust-coreutils (0.0.16-2) unstable; urgency=medium

  * Run the tests (but don't fail the build if not 100%)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 03 Nov 2022 09:55:03 +0100

rust-coreutils (0.0.16-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 03 Nov 2022 09:34:36 +0100

rust-coreutils (0.0.15-1) unstable; urgency=medium

  * New upstream release
    - Update of the desc as all binaries exist now
      (some options are still missing)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 17 Sep 2022 13:54:25 +0200

rust-coreutils (0.0.14-4~exp2) experimental; urgency=medium

  * Fix the FTBFS on 32 bit with selinux

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 05 Aug 2022 19:08:59 +0200

rust-coreutils (0.0.14-4~exp1) experimental; urgency=medium

  * Use symlink instead of multiple binaries.
    Works the same way but decrease the footprint
    Use changes from apertus:
    https://gitlab.apertis.org/pkg/rust-coreutils/-/tree/apertis/v2023dev1/debian
  * Be more explicit for some dependencies
  * Build selinux binaries

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 04 Aug 2022 14:48:40 +0200

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libstd-rust-dev,
 librust-clap-dev (>= 3.2), librust-clap-complete-dev,
 librust-backtrace-dev,
 librust-half-1.6+default-dev | librust-half-1.3+default-dev | librust-half-1.2+default-dev | librust-half-1.1+default-dev,
 librust-lazy-static-1+default-dev (>= 1.3-~~),
 librust-same-file-1.0.6+default-dev | librust-same-file-1.0.5+default-dev | librust-same-file-1.0.4+default-dev,
 librust-textwrap-dev (>= 0.16.0), librust-cc-dev,
 librust-quick-error-dev (>= 2.0), librust-unix-socket-dev, librust-getopts-dev,
 librust-filetime-dev (>= 0.2.17),
 librust-walkdir-dev (>= 2.3.2), librust-xattr-dev, librust-number-prefix-dev,
 librust-rust-ini-dev (>= 0.18.0), librust-failure-dev, librust-failure-derive-dev,
 librust-glob-dev, librust-chrono-dev, librust-onig-dev (>= 6.3),
 librust-blake2-rfc-dev, librust-digest-dev (>= 0.10.5), librust-hex-dev, librust-md5-dev,
 librust-sha1-dev (>= 0.10.1), librust-sha2-dev, librust-sha3-dev,
 librust-atty-dev, librust-term-grid-dev, librust-termsize-dev,
 librust-tempfile-dev, librust-nix-dev (>= 0.25.0), librust-fs-extra-dev,
 librust-itertools-dev, librust-bit-set-dev, librust-dunce-dev (>= 1.0.3),
 librust-data-encoding-dev, librust-platform-info-dev (>= 1.0.2),
 librust-num-traits-dev (>= 0.2.14), librust-smallvec-dev (>= 1.9.0),
 librust-rand-pcg-dev, librust-thiserror-dev, librust-lazy-static-dev,
 librust-byteorder-dev, librust-hostname-dev (>= 0.3.1), librust-cpp-build-dev,
 librust-fnv-dev, librust-wild-dev, librust-cpp-dev, librust-thread-local-dev,
 librust-selinux-dev (>= 0.3.0), librust-conv-dev, librust-pretty-assertions-dev (>= 1),
 librust-time-dev (>= 0.3.9), librust-unindent-dev, librust-rlimit-dev (>= 0.8.3),
 librust-data-encoding-macro-dev, librust-dns-lookup-dev, librust-os-display-dev,
 librust-z85-dev, librust-fts-sys-dev, librust-exacl-dev, librust-byte-unit-dev,
 librust-gcd-dev, librust-signal-hook-dev, librust-paste-dev, librust-quickcheck-dev,
 librust-crossterm-dev (>= 0.25.0), librust-bigdecimal-dev, librust-binary-heap-plus-dev,
 librust-ouroboros-dev, librust-memmap2-dev (>= 0.5), librust-retain-mut-dev (>= 0.1.7),
 librust-strum-dev, librust-utf-8-dev, librust-phf-dev, librust-phf-codegen-dev,
 librust-zip-dev, librust-users-dev, librust-blake2b-simd-dev,
 librust-hex-literal-dev, librust-lscolors-0.13-dev, librust-blake3-dev,
 librust-file-diff-dev, librust-ctrlc-dev, librust-flate2-dev,
 librust-bstr-dev, librust-md-5-dev, librust-bytecount-dev (>= 0.6.3),
 librust-regex-automata-dev, librust-notify-dev,
 librust-procfs-dev, librust-terminal-size-dev (>= 0.2.1),
 librust-indicatif-dev (>= 0.17.3),
 librust-backtrace-sys-dev, python3-sphinx, help2man
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.5.1
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.
 .
 It might break your system.
 .
 This is an EXPERIMENTAL package. It should not be used in
 production.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")


# Build a multicall binary instead of multiple binaries
# to reduce the storage footprint
export MULTICALL = y

%:
	dh $@ --buildsystem cargo

override_dh_auto_test:
	# for now, don't fail the build if tests are failing
	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) test||true

override_dh_auto_install:
	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system
	CARGO_HOME=$(CURDIR)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make SELINUX_ENABLED=1 PROFILE=release MULTICALL=$(MULTICALL) install
# Create the symlink early to be able to generate the manpages
	dh_link

override_dh_missing:
	dh_missing --fail-missing

execute_before_dh_installman:
	cd $(CURDIR)/debian/rust-coreutils/usr/lib/cargo/bin/coreutils/; \
	for f in *; do \
		filename=$$(basename $$f); \
		help2man --no-info $$f > $(CURDIR)/docs/rust-$$filename.1; \
	done
	
	cd $(CURDIR)/debian/tmp/usr/bin/; \
	help2man --no-info coreutils > $(CURDIR)/docs/coreutils.1 || true
	
	# test --help returns nothing
	rm -f $(CURDIR)/docs/rust-test.1

## rust-coreutils 0.0.20

=== debian/changelog ===
rust-coreutils (0.0.20-1) unstable; urgency=medium

  * New upstream release
  * librust-self-cell-dev is a new dep
  * Standards-Version updated 4.6.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 16 Jul 2023 18:34:00 +0200

rust-coreutils (0.0.19-3) unstable; urgency=medium

  * Team upload.
  * On 32-bit architectures, reduce debuginfo level and use thin lto rather
    than full lto to avoid issues with running out of address space.

 -- Peter Michael Green <plugwash@debian.org>  Sun, 16 Jul 2023 00:20:58 +0000

rust-coreutils (0.0.19-2) unstable; urgency=medium

  * Add missing build dep
    librust-clap-mangen-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 14 Jul 2023 17:17:12 +0200

rust-coreutils (0.0.19-1) unstable; urgency=medium

  [ Peter Michael Green ]
  * Drop empty patch lower-zip.diff
  * Drop relax-bstr.diff
  * Build-depend explicitly on version 4 of clap and clap-complete.

  [ Sylvestre Ledru ]
  * New upstream release
  * Add override_dh_dwz

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 10 Jun 2023 14:04:16 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,8 @@
  cargo:native,
  rustc:native,
  libstd-rust-dev,
- librust-clap-dev (>= 3.2), librust-clap-complete-dev,
+ librust-clap-4-dev, librust-clap-complete-4-dev,
+ librust-clap-mangen-dev,
  librust-backtrace-dev,
  librust-half-1.6+default-dev | librust-half-1.3+default-dev | librust-half-1.2+default-dev | librust-half-1.1+default-dev,
  librust-lazy-static-1+default-dev (>= 1.3-~~),
@@ -15,39 +16,41 @@
  librust-textwrap-dev (>= 0.16.0), librust-cc-dev,
  librust-quick-error-dev (>= 2.0), librust-unix-socket-dev, librust-getopts-dev,
  librust-filetime-dev (>= 0.2.17),
- librust-walkdir-dev (>= 2.3.2), librust-xattr-dev, librust-number-prefix-dev,
+ librust-walkdir-dev (>= 2.3.2), librust-xattr-dev (>= 1.0.0), librust-number-prefix-dev,
  librust-rust-ini-dev (>= 0.18.0), librust-failure-dev, librust-failure-derive-dev,
  librust-glob-dev, librust-chrono-dev, librust-onig-dev (>= 6.3),
  librust-blake2-rfc-dev, librust-digest-dev (>= 0.10.5), librust-hex-dev, librust-md5-dev,
  librust-sha1-dev (>= 0.10.1), librust-sha2-dev, librust-sha3-dev,
  librust-atty-dev, librust-term-grid-dev, librust-termsize-dev,
  librust-tempfile-dev, librust-nix-dev (>= 0.25.0), librust-fs-extra-dev,
- librust-itertools-dev, librust-bit-set-dev, librust-dunce-dev (>= 1.0.3),
+ librust-itertools-dev (>= 0.10.5), librust-bit-set-dev, librust-dunce-dev (>= 1.0.3),
  librust-data-encoding-dev, librust-platform-info-dev (>= 1.0.2),
  librust-num-traits-dev (>= 0.2.14), librust-smallvec-dev (>= 1.9.0),
  librust-rand-pcg-dev, librust-thiserror-dev, librust-lazy-static-dev,
  librust-byteorder-dev, librust-hostname-dev (>= 0.3.1), librust-cpp-build-dev,
  librust-fnv-dev, librust-wild-dev, librust-cpp-dev, librust-thread-local-dev,
  librust-selinux-dev (>= 0.3.0), librust-conv-dev, librust-pretty-assertions-dev (>= 1),
- librust-time-dev (>= 0.3.9), librust-unindent-dev, librust-rlimit-dev (>= 0.8.3),
+ librust-time-dev (>= 0.3.9), librust-unindent-dev (>= 0.2.1), librust-rlimit-dev (>= 0.8.3),
  librust-data-encoding-macro-dev, librust-dns-lookup-dev, librust-os-display-dev,
  librust-z85-dev, librust-fts-sys-dev, librust-exacl-dev, librust-byte-unit-dev,
- librust-gcd-dev, librust-signal-hook-dev, librust-paste-dev, librust-quickcheck-dev,
+ librust-gcd-dev, librust-signal-hook-dev (>= 0.3.15), librust-paste-dev, librust-quickcheck-dev,
  librust-crossterm-dev (>= 0.25.0), librust-bigdecimal-dev, librust-binary-heap-plus-dev,
  librust-ouroboros-dev, librust-memmap2-dev (>= 0.5), librust-retain-mut-dev (>= 0.1.7),
  librust-strum-dev, librust-utf-8-dev, librust-phf-dev, librust-phf-codegen-dev,
  librust-zip-dev, librust-users-dev, librust-blake2b-simd-dev,
- librust-hex-literal-dev, librust-lscolors-0.13-dev, librust-blake3-dev,
- librust-file-diff-dev, librust-ctrlc-dev, librust-flate2-dev,
- librust-bstr-dev, librust-md-5-dev, librust-bytecount-dev (>= 0.6.3),
+ librust-hex-literal-dev, librust-lscolors-dev (>= 0.14.0-4), librust-blake3-dev,
+ librust-file-diff-dev, librust-ctrlc-dev (>= 3.4.0), librust-flate2-dev,
+ librust-bstr-dev (>= 1.5.0), librust-md-5-dev, librust-bytecount-dev (>= 0.6.3),
  librust-regex-automata-dev, librust-notify-dev,
  librust-procfs-dev, librust-terminal-size-dev (>= 0.2.1),
  librust-indicatif-dev (>= 0.17.3),
+ librust-fundu-dev, librust-parse-datetime-dev,
+ librust-is-terminal-dev, librust-sm3-dev, librust-self-cell-dev,
  librust-backtrace-sys-dev, python3-sphinx, help2man
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Sylvestre Ledru <sylvestre@debian.org>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
 Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
 Homepage: https://github.com/uutils/coreutils

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
 VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
-
+UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)
 
 # Build a multicall binary instead of multiple binaries
 # to reduce the storage footprint
@@ -20,7 +20,14 @@
 
 override_dh_auto_install:
 	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system
+#use thin rather than full lto on 32-bit to avoid running out of address space.
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+	sed -i 's/lto = true/lto = "thin"/' Cargo.toml
+endif
 	CARGO_HOME=$(CURDIR)/debian/cargo_home DESTDIR=$(CURDIR)/debian/tmp/ make SELINUX_ENABLED=1 PROFILE=release MULTICALL=$(MULTICALL) install
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
+endif
 # Create the symlink early to be able to generate the manpages
 	dh_link
 
@@ -31,11 +38,21 @@
 	cd $(CURDIR)/debian/rust-coreutils/usr/lib/cargo/bin/coreutils/; \
 	for f in *; do \
 		filename=$$(basename $$f); \
-		help2man --no-info $$f > $(CURDIR)/docs/rust-$$filename.1; \
+		help2man --no-discard-stderr --no-info $$f > $(CURDIR)/docs/rust-$$filename.1; \
 	done
 	
 	cd $(CURDIR)/debian/tmp/usr/bin/; \
-	help2man --no-info coreutils > $(CURDIR)/docs/coreutils.1 || true
+	PATH=.:$PATH help2man --no-discard-stderr --no-info --version-string=$(UPSTREAM_VERSION) coreutils > $(CURDIR)/docs/coreutils.1 || true
 	
 	# test --help returns nothing
 	rm -f $(CURDIR)/docs/rust-test.1
+
+override_dh_dwz:
+	# Don't do anything. fails because of the
+	# https://github.com/rust-lang/rust/issues/66118
+
+#use lower debuginfo level on 32-bit to avoid running out of address space.
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+execute_after_dh_auto_configure:
+	sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config
+endif

## rust-coreutils 0.0.24

=== debian/changelog ===
rust-coreutils (0.0.24-2) unstable; urgency=medium

  * Team upload.
  * Relax cargo dependency on notify crate.
  * Reduce context in patches to avoid conflicts.

 -- Peter Michael Green <plugwash@debian.org>  Sun, 25 Feb 2024 10:07:14 +0000

rust-coreutils (0.0.24-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 29 Jan 2024 14:43:13 +0100

rust-coreutils (0.0.23-3) unstable; urgency=medium

  * Team upload.
  * Fix Debian dependency for "half" crate.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 25 Jan 2024 08:27:35 +0000

rust-coreutils (0.0.23-2) unstable; urgency=medium

  * Team upload.
  * Relax crossterm dependency.

 -- Peter Michael Green <plugwash@debian.org>  Wed, 22 Nov 2023 17:02:31 +0000

rust-coreutils (0.0.23-1) unstable; urgency=medium

  * New upstream release
  * Fix "Fails to build source after successful build"
    (closes: #1046006)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Nov 2023 12:38:26 +0100

rust-coreutils (0.0.22-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 15 Oct 2023 22:04:25 +0200

rust-coreutils (0.0.21-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 03 Sep 2023 18:58:30 +0200

=== debian/rules ===
--- 
+++ 
@@ -34,19 +34,6 @@
 override_dh_missing:
 	dh_missing --fail-missing
 
-execute_before_dh_installman:
-	cd $(CURDIR)/debian/rust-coreutils/usr/lib/cargo/bin/coreutils/; \
-	for f in *; do \
-		filename=$$(basename $$f); \
-		help2man --no-discard-stderr --no-info $$f > $(CURDIR)/docs/rust-$$filename.1; \
-	done
-	
-	cd $(CURDIR)/debian/tmp/usr/bin/; \
-	PATH=.:$PATH help2man --no-discard-stderr --no-info --version-string=$(UPSTREAM_VERSION) coreutils > $(CURDIR)/docs/coreutils.1 || true
-	
-	# test --help returns nothing
-	rm -f $(CURDIR)/docs/rust-test.1
-
 override_dh_dwz:
 	# Don't do anything. fails because of the
 	# https://github.com/rust-lang/rust/issues/66118
@@ -56,3 +43,7 @@
 execute_after_dh_auto_configure:
 	sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config
 endif
+
+override_dh_clean:
+	rm -f Cargo.toml.orig Cargo.lock
+	dh_clean

## rust-coreutils 0.0.26

=== debian/changelog ===
rust-coreutils (0.0.26-5) unstable; urgency=medium

  * Only apply the debug sed if the file exists (Closes: #1082938)
  * Fix the half dependency (Closes: #1083058) - was fixed in the previous
    upload but not closed

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 06 Oct 2024 10:58:56 +0200

rust-coreutils (0.0.26-4) unstable; urgency=medium

  * Team upload.
  * Stop patching cargo dependenies on half and glob. Update Debian build
    dependencies accordingly.
  * Reduce context in relax-itertools.diff, relax-gcd.diff, relax-fundu.diff
    and relax-hostname.diff to avoid fuzz.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 19 Sep 2024 14:50:41 +0000

rust-coreutils (0.0.26-3) unstable; urgency=medium

  * Relax notify dependency to support 6.x

 -- James McCoy <jamessan@debian.org>  Tue, 11 Jun 2024 16:29:09 -0400

rust-coreutils (0.0.26-2) unstable; urgency=medium

  * Team upload

  [ Sylvestre Ledru ]
  * As nix & chrono have been updated, remove the upstream cherry-picked
    patches

  [ Peter Michael Green ]
  * Fix build on 32-bit architectures with time64 (Closes: #1071048)
    + Use mem::zeroed to create timespec structs as they contain padding on
      time64 architectures.
    + Build-depend on librust-selinux-sys-dev (>= 0.6.7-2)  to pick up time64
      fix.
  * Add patch to support nix 0.27 (upstream uses 0.28).
  * Tighten nix dependency in debian/control, the nix 0.27 patch will need
    to be removed when debian upgrades to nix 0.28.

 -- Peter Michael Green <plugwash@debian.org>  Wed, 15 May 2024 00:16:03 +0000

rust-coreutils (0.0.26-1) unstable; urgency=medium

  * New upstream release
    (Closes: #1067897, #1069413)
    Adds support for loongarch (Closes: #1059268)
  * remove librust-failure-dev, librust-failure-derive-dev unused deps
  * remove help2man from the build deps (not used)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 01 May 2024 14:03:13 +0200

=== debian/control ===
--- 
+++ 
@@ -10,26 +10,26 @@
  librust-clap-4-dev, librust-clap-complete-4-dev,
  librust-clap-mangen-dev,
  librust-backtrace-dev,
- librust-half-1.6+default-dev | librust-half-1.3+default-dev | librust-half-1.2+default-dev | librust-half-1.1+default-dev,
+ librust-half-2+default-dev (>= 2.4),
  librust-lazy-static-1+default-dev (>= 1.3-~~),
  librust-same-file-1.0.6+default-dev | librust-same-file-1.0.5+default-dev | librust-same-file-1.0.4+default-dev,
  librust-textwrap-dev (>= 0.16.0), librust-cc-dev,
  librust-quick-error-dev (>= 2.0), librust-unix-socket-dev, librust-getopts-dev,
  librust-filetime-dev (>= 0.2.17),
  librust-walkdir-dev (>= 2.3.2), librust-xattr-dev (>= 1.0.0), librust-number-prefix-dev,
- librust-rust-ini-dev (>= 0.18.0), librust-failure-dev, librust-failure-derive-dev,
- librust-glob-dev, librust-chrono-dev, librust-onig-dev (>= 6.3),
+ librust-rust-ini-dev (>= 0.18.0),
+ librust-glob-dev (>= 0.3.1), librust-chrono-dev (>= 0.4.31), librust-onig-dev (>= 6.3),
  librust-blake2-rfc-dev, librust-digest-dev (>= 0.10.5), librust-hex-dev, librust-md5-dev,
  librust-sha1-dev (>= 0.10.1), librust-sha2-dev, librust-sha3-dev,
- librust-atty-dev, librust-term-grid-dev, librust-termsize-dev,
- librust-tempfile-dev, librust-nix-dev (>= 0.25.0), librust-fs-extra-dev,
+ librust-atty-dev, librust-uutils-term-grid-dev (>= 0.6.0), librust-termsize-dev,
+ librust-tempfile-dev, librust-nix-0.27-dev, librust-fs-extra-dev,
  librust-itertools-dev (>= 0.10.5), librust-bit-set-dev, librust-dunce-dev (>= 1.0.3),
  librust-data-encoding-dev, librust-platform-info-dev (>= 1.0.2),
  librust-num-traits-dev (>= 0.2.14), librust-smallvec-dev (>= 1.9.0),
  librust-rand-pcg-dev, librust-thiserror-dev, librust-lazy-static-dev,
  librust-byteorder-dev, librust-hostname-dev (>= 0.3.1), librust-cpp-build-dev,
  librust-fnv-dev, librust-wild-dev, librust-cpp-dev, librust-thread-local-dev,
- librust-selinux-dev (>= 0.3.0), librust-conv-dev, librust-pretty-assertions-dev (>= 1),
+ librust-selinux-dev (>= 0.3.0), librust-selinux-sys-dev (>= 0.6.7-2), librust-conv-dev, librust-pretty-assertions-dev (>= 1),
  librust-time-dev (>= 0.3.9), librust-unindent-dev (>= 0.2.1), librust-rlimit-dev (>= 0.8.3),
  librust-data-encoding-macro-dev, librust-dns-lookup-dev, librust-os-display-dev,
  librust-z85-dev, librust-fts-sys-dev, librust-exacl-dev, librust-byte-unit-dev,
@@ -46,7 +46,8 @@
  librust-indicatif-dev (>= 0.17.3),
  librust-fundu-dev, librust-parse-datetime-dev,
  librust-is-terminal-dev, librust-sm3-dev, librust-self-cell-dev,
- librust-backtrace-sys-dev, python3-sphinx, help2man
+ librust-uutils-term-grid-dev, librust-rstest-dev,
+ librust-backtrace-sys-dev, python3-sphinx
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Sylvestre Ledru <sylvestre@debian.org>

=== debian/rules ===
--- 
+++ 
@@ -41,7 +41,9 @@
 #use lower debuginfo level on 32-bit to avoid running out of address space.
 ifeq ($(DEB_HOST_ARCH_BITS),32)
 execute_after_dh_auto_configure:
-	sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config
+	if test -f debian/cargo_home/config; then \
+		sed -i s/debuginfo=2/debuginfo=1/ debian/cargo_home/config; \
+	fi
 endif
 
 override_dh_clean:

## rust-coreutils 0.0.27

=== debian/changelog ===
rust-coreutils (0.0.27-2) unstable; urgency=medium

  * Team upload.
  * Update for nix 0.28 (Closes: #1085563)
    + Drop relax-nix.patch and nix-0.27.patch
    + Add new patch for nix 0.29
  * Add patch to support rust-ini 0.18, since newer version is blocked on
    rust-trim-in-place clearing NEW.
  * Reduce context in patches to avoid problems applying them after changes
    in other patches.

 -- Peter Michael Green <plugwash@debian.org>  Sun, 03 Nov 2024 17:56:48 +0000

rust-coreutils (0.0.27-1) unstable; urgency=medium

  * New upstream release
  * Disable factor as num-prime isn't working in Debian yet

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 03 Nov 2024 00:31:47 +0100

=== debian/control ===
--- 
+++ 
@@ -17,12 +17,15 @@
  librust-quick-error-dev (>= 2.0), librust-unix-socket-dev, librust-getopts-dev,
  librust-filetime-dev (>= 0.2.17),
  librust-walkdir-dev (>= 2.3.2), librust-xattr-dev (>= 1.0.0), librust-number-prefix-dev,
+ librust-ansi-width-dev,
+# librust-num-prime-dev,
+ librust-bincode-dev, librust-serde-big-array-dev,
  librust-rust-ini-dev (>= 0.18.0),
  librust-glob-dev (>= 0.3.1), librust-chrono-dev (>= 0.4.31), librust-onig-dev (>= 6.3),
  librust-blake2-rfc-dev, librust-digest-dev (>= 0.10.5), librust-hex-dev, librust-md5-dev,
  librust-sha1-dev (>= 0.10.1), librust-sha2-dev, librust-sha3-dev,
  librust-atty-dev, librust-uutils-term-grid-dev (>= 0.6.0), librust-termsize-dev,
- librust-tempfile-dev, librust-nix-0.27-dev, librust-fs-extra-dev,
+ librust-tempfile-dev, librust-nix-0.29-dev, librust-fs-extra-dev,
  librust-itertools-dev (>= 0.10.5), librust-bit-set-dev, librust-dunce-dev (>= 1.0.3),
  librust-data-encoding-dev, librust-platform-info-dev (>= 1.0.2),
  librust-num-traits-dev (>= 0.2.14), librust-smallvec-dev (>= 1.9.0),

=== debian/rules ===
--- 
+++ 
@@ -29,6 +29,9 @@
 	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
 endif
 # Create the symlink early to be able to generate the manpages
+	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && mv _* rust-coreutils
+	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
+#	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
 	dh_link
 
 override_dh_missing:

## rust-coreutils 0.0.30

=== debian/changelog ===
rust-coreutils (0.0.30-2ubuntu2) questing; urgency=medium

  * Add missing libselinux1-dev, libclang-dev build dependencies

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 03 Jun 2025 13:27:37 +0200

rust-coreutils (0.0.30-2ubuntu1) questing; urgency=medium

  * Vendor dependencies
    - debian/rules:
      + Add vendoring rules
      + Move the prepare-debian call to override_dh_auto_configure and adjust it
        to use our vendored dependencies
    - debian/patches:
      + Add workspace-exclude.patch to exclude vendored crates from the workspace
      + Drop all the patches to adjust crate versions
      + Drop all the patches to adjust code to different crate versions
      + Drop all the patches to disable certain programs or windows
        dependencies, as we can now
  * Build factor, basenc and install links for them
  * Build stty binary (LP: #2111211)

 -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 03 Jun 2025 12:24:02 +0200

rust-coreutils (0.0.30-2) unstable; urgency=medium

  [ Dylan Aïssi ]
  * disable stdbuf
  * tweak build profile for right balance between the smallest binary size and enough debug info

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 24 Apr 2025 21:02:55 +0200

rust-coreutils (0.0.30-1) unstable; urgency=medium

  * New upstream release
    (Closes: #1101590)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 04 Apr 2025 23:49:25 +0200

rust-coreutils (0.0.27-3) unstable; urgency=medium

  [ NoisyCoil ]
  * Team upload.
  * Package coreutils 0.0.27 from crates.io using debcargo 2.7.5
  * Remove unused librust-users-dev build-dependency
    (Closes: #1089872)

  [ Sylvestre Ledru ]
  * Update of the description. Thanks to Dylan Aissi
  * Fix the executable-not-elf-or-script warning
  * Remove old patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 22 Dec 2024 13:56:37 +0100

=== debian/control ===
Source: rust-coreutils
Section: utils
Priority: optional
Build-Depends: debhelper (>= 12),
 dh-cargo (>= 24),
 dh-sequence-bash-completion,
 cargo:native,
 rustc:native,
 libselinux1-dev,
 libclang-dev,
 python3-sphinx,
XS-Vendored-Sources-Rust: adler2@2.0.0, aho-corasick@1.1.3, allocator-api2@0.2.21, ansi-width@0.1.0, anstream@0.6.18, anstyle-parse@0.2.6, anstyle-query@1.1.2, anstyle@1.0.10, arrayref@0.3.9, arrayvec@0.7.6, autocfg@1.4.0, bigdecimal@0.4.7, binary-heap-plus@0.5.0, bincode@1.3.3, bindgen@0.70.1, bindgen@0.71.1, bitflags@1.3.2, bitflags@2.9.0, bitvec@1.0.1, blake2b_simd@1.0.3, blake3@1.6.1, block-buffer@0.10.4, bstr@1.11.3, bumpalo@3.17.0, bytecount@0.6.8, byteorder@1.5.0, cc@1.2.16, cexpr@0.6.0, cfg-if@1.0.0, cfg_aliases@0.2.1, chrono-tz-build@0.4.0, chrono-tz@0.10.1, chrono@0.4.40, clang-sys@1.8.1, clap@4.5.31, clap_builder@4.5.31, clap_complete@4.5.46, clap_lex@0.7.4, clap_mangen@0.2.26, colorchoice@1.0.3, compare@0.1.0, console@0.15.11, const-random-macro@0.1.16, const-random@0.1.18, constant_time_eq@0.3.1, coz@0.1.3, cpp@0.5.10, cpp_build@0.5.10, cpp_common@0.5.10, cpp_macros@0.5.10, cpufeatures@0.2.17, crc32fast@1.4.2, crossbeam-deque@0.8.6, crossbeam-epoch@0.9.18, crossbeam-utils@0.8.21, crossterm@0.28.1, crunchy@0.2.3, crypto-common@0.1.6, ctrlc@3.4.5, data-encoding-macro-internal@0.1.15, data-encoding-macro@0.1.17, data-encoding@2.8.0, deranged@0.3.11, diff@0.1.13, digest@0.10.7, displaydoc@0.2.5, dlv-list@0.5.2, dns-lookup@2.0.4, dunce@1.0.5, either@1.15.0, equivalent@1.0.2, errno@0.3.10, exacl@0.12.0, fastrand@2.3.0, file_diff@1.0.0, filedescriptor@0.8.3, filetime@0.2.25, flate2@1.1.0, fnv@1.0.7, foldhash@0.1.4, fs_extra@1.3.0, fts-sys@0.2.14, fundu-core@0.3.1, fundu@2.0.1, funty@2.0.0, futures-core@0.3.31, futures-macro@0.3.31, futures-task@0.3.31, futures-timer@3.0.3, futures-util@0.3.31, gcd@2.3.0, generic-array@0.14.7, getrandom@0.2.15, getrandom@0.3.1, glob@0.3.2, half@2.4.1, hashbrown@0.14.5, hashbrown@0.15.2, hex-literal@0.4.1, hex@0.4.3, hostname@0.4.0, iana-time-zone@0.1.61, indexmap@2.7.1, indicatif@0.17.11, inotify-sys@0.1.5, inotify@0.11.0, is_terminal_polyfill@1.70.1, itertools@0.13.0, itertools@0.14.0, itoa@1.0.15, keccak@0.1.5, lazy_static@1.5.0, libc@0.2.170, libloading@0.8.6, libm@0.2.11, linux-raw-sys@0.4.15, linux-raw-sys@0.9.2, lock_api@0.4.12, lockfree-object-pool@0.1.6, log@0.4.26, lru@0.12.5, lscolors@0.20.0, md-5@0.10.6, memchr@2.7.4, memmap2@0.9.5, minimal-lexical@0.2.1, miniz_oxide@0.8.5, mio@1.0.3, nix@0.29.0, nom@7.1.3, nom@8.0.0, notify-types@2.0.0, notify@8.0.0, nu-ansi-term@0.50.1, num-bigint@0.4.6, num-conv@0.1.0, num-integer@0.1.46, num-modular@0.5.1, num-prime@0.4.4, num-traits@0.2.19, num_threads@0.1.7, number_prefix@0.4.0, once_cell@1.20.3, onig@6.4.0, onig_sys@69.8.1, ordered-multimap@0.7.3, os_display@0.1.3, parking_lot@0.12.3, parking_lot_core@0.9.10, parse-zoneinfo@0.3.1, parse_datetime@0.8.0, phf@0.11.3, phf_codegen@0.11.3, phf_generator@0.11.3, phf_shared@0.11.3, pin-project-lite@0.2.16, pin-utils@0.1.0, pkg-config@0.3.32, platform-info@2.0.5, portable-atomic@1.11.0, powerfmt@0.2.0, ppv-lite86@0.2.20, pretty_assertions@1.4.1, prettyplease@0.2.30, proc-macro-crate@3.3.0, proc-macro2@1.0.94, procfs-core@0.17.0, procfs@0.17.0, quick-error@2.0.1, quote@1.0.39, radium@0.7.0, rand@0.8.5, rand@0.9.0, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rayon-core@1.12.1, rayon@1.10.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, relative-path@1.9.3, rlimit@0.10.2, roff@0.2.2, rstest@0.25.0, rstest_macros@0.25.0, rust-ini@0.21.1, rustc-hash@1.1.0, rustc-hash@2.1.1, rustc_version@0.4.1, rustix@0.38.44, rustix@1.0.1, same-file@1.0.6, scopeguard@1.2.0, self_cell@1.1.0, selinux-sys@0.6.13, selinux@0.5.0, semver@1.0.26, serde-big-array@0.5.1, serde@1.0.218, serde_derive@1.0.218, sha1@0.10.6, sha2@0.10.8, sha3@0.10.8, shlex@1.3.0, signal-hook-mio@0.2.4, signal-hook-registry@1.4.2, signal-hook@0.3.17, simd-adler32@0.3.7, siphasher@1.0.1, slab@0.4.9, sm3@0.4.2, smallvec@1.14.0, smawk@0.3.2, socket2@0.5.8, strsim@0.11.1, syn@2.0.99, tap@1.0.1, tempfile@3.18.0, terminal_size@0.4.1, textwrap@0.16.2, thiserror-impl@1.0.69, thiserror-impl@2.0.12, thiserror@1.0.69, thiserror@2.0.12, time-core@0.1.3, time-macros@0.2.20, time@0.3.39, tiny-keccak@2.0.2, toml_datetime@0.6.8, toml_edit@0.22.24, trim-in-place@0.1.7, typenum@1.18.0, unicode-ident@1.0.18, unicode-linebreak@0.1.5, unicode-segmentation@1.12.0, unicode-width@0.1.14, unicode-width@0.2.0, unicode-xid@0.2.6, unindent@0.2.4, utf8parse@0.2.2, uuid@1.15.1, uutils_term_grid@0.6.0, version_check@0.9.5, walkdir@2.5.0, wild@2.2.1, winnow@0.7.3, wyz@0.5.1, xattr@1.5.0, yansi@1.0.1, z85@3.0.6, zerocopy-derive@0.7.35, zerocopy@0.7.35, zerocopy@0.8.23, zip@2.2.3, zopfli@0.8.1
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Sylvestre Ledru <sylvestre@debian.org>
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/coreutils]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/coreutils
Homepage: https://github.com/uutils/coreutils
Rules-Requires-Root: no

Package: rust-coreutils
Architecture: any
Multi-Arch: allowed
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${cargo:Depends}
Recommends:
 ${cargo:Recommends}
Suggests:
 ${cargo:Suggests}
Provides:
 ${cargo:Provides}
Built-Using: ${cargo:Built-Using}
XB-X-Cargo-Built-Using: ${cargo:X-Cargo-Built-Using}
Description: Universal coreutils utils, written in Rust
 This packages replaces the GNU coreutils package written in C.
 It should be a drop-in replacement but:
  * Some options have NOT been implemented,
  * Might have important bugs,
  * Might be slower,
  * Output of the binaries might be slightly different.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 include /usr/share/rustc/architecture.mk
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE
+export CARGO_PROFILE_RELEASE_DEBUG=true
+export SKIP_UTILS=stdbuf
 VERSION := $(shell dpkg-parsechangelog -S Version|sed -e "s|.*~\(.*\)-.*|\1|g")
 UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version|cut -d- -f1)
 
@@ -11,15 +13,52 @@
 # to reduce the storage footprint
 export MULTICALL = y
 
+# Vendoring setup
+# FIXME: The upstream Makefile we use doesn't work with the cargo wrapper,
+# as it assumes no cross-compilation and hence files appearing in target/release
+# rather than the architecture-specific target directory.
+#export CARGO = /usr/share/cargo/bin/cargo
+export CARGO_VENDOR_DIR = rust-vendor
+export CARGO_HOME = $(CURDIR)/debian/cargo_home
+VENDOR_TARBALL = rust-coreutils_$(UPSTREAM_VERSION).orig-$(CARGO_VENDOR_DIR).tar.xz
+
 %:
 	dh $@ --buildsystem cargo
+
+vendor-tarball-quick-check:
+	if [ -e ../$(VENDOR_TARBALL) ]; then echo "../$(VENDOR_TARBALL) already exists, bailing!"; exit 1; fi
+
+vendor-deps-cargo:
+	rm -rf $(CARGO_VENDOR_DIR)
+	# Deliberately don't use the wrapper, as it expects the configure step
+	# to have occurred already.
+	# If you have to modify the path here, don't forget to change the README.source doc
+	# as well.
+	env -i cargo-vendor-filterer --all-features  --tier 2  --platform '*-*-linux-gnu' --platform '*-*-linux-gnueabi' $(CARGO_VENDOR_DIR)
+
+vendor-deps: vendor-deps-cargo
+	rm -r \
+		$(CARGO_VENDOR_DIR)/*/tests
+	# Remove the checksum files to allow us to patch the crates to remove extraneous dependencies
+	for crate in $(CARGO_VENDOR_DIR)/*; do \
+		sed -i 's/^{"files":.*"package":"\([a-z0-9]\+\)"}$$/{"files":{},"package":"\1"}/' $$crate/.cargo-checksum.json; \
+		done
+	# Cleanup temp files
+	rm -rf $(CARGO_HOME)
+
+vendor-tarball: vendor-tarball-quick-check vendor-deps
+	tar --sort=name --mtime=@0 --owner=0 --group=0 --numeric-owner --pax-option=exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime -caf ../$(VENDOR_TARBALL) $(CARGO_VENDOR_DIR)
+
+override_dh_auto_configure:
+	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian $(CARGO_VENDOR_DIR)
+	/usr/share/cargo/bin/dh-cargo-vendored-sources
+	dh_auto_configure
 
 override_dh_auto_test:
 	# for now, don't fail the build if tests are failing
 	CARGO_HOME=$(CURDIR)/debian/cargo_home make PROFILE=release MULTICALL=$(MULTICALL) test||true
 
 override_dh_auto_install:
-	CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=coreutils_$(VERSION) /usr/share/cargo/bin/cargo prepare-debian debian/cargo_registry --link-from-system
 #use thin rather than full lto on 32-bit to avoid running out of address space.
 ifeq ($(DEB_HOST_ARCH_BITS),32)
 	sed -i 's/lto = true/lto = "thin"/' Cargo.toml
@@ -29,7 +68,9 @@
 	sed -i 's/lto = "thin"/lto = true/' Cargo.toml
 endif
 # Create the symlink early to be able to generate the manpages
-	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && mv _* rust-coreutils
+	cd debian/tmp/usr/share/zsh/site-functions && mkdir rust-coreutils && chmod -x _* && mv _* rust-coreutils
+	cd debian/tmp/usr/share/bash-completion/completions/ && chmod -x rust-*
+	cd debian/tmp/usr/share/fish/vendor_completions.d/ && chmod -x *.fish
 	cd debian/tmp/usr/bin && mv rust-coreutils coreutils && rm rust-*
 #	cd debian/tmp/usr/share/fish/vendor_completions.d && for f in *fish; do mv $$f rust-$$f; done
 	dh_link
